<template lang="pug">
.flight-widget
  .flight-widget__title(
    v-if="title"
    v-html="title"
  )

  form.flight-widget-form(
    autocomplete="off"
    @submit.prevent="submit"
    v-if="!successMessage"
  )
    .flight-widget-form__inputs
      .flight-widget-form__single(
        v-for="(flight, flightIndex) in form.flights"
        :key="flightIndex"
      )
        .flight-widget-form__item.icon-plane_up(
          :class="{ 'is-filled': form.flights[flightIndex].origin_text || ($v.form.flights.$each[flightIndex].origin_text.$dirty && $v.form.flights.$each[flightIndex].origin_text.$invalid) || destinationFilled }"
        )
          .flight-widget-form__placeholder {{ $t('booking.departure') }}
          span.form-item__error(v-if="$v.form.flights.$each[flightIndex].origin_text.$dirty && !$v.form.flights.$each[flightIndex].origin_text.required") {{ $t('forms.errors.required') }}
          .flight-widget-form__input
            input(
              type="text"
              @focus="inputFocus($event, 'destination', flightIndex)"
              @input="inputChange($event, 'destination', flightIndex)"
              @blur="inputBlur($event)"
              v-model="form.flights[flightIndex].origin_text"
            )

        .flight-widget-form__item.icon-plane_down(
          :class="{ 'is-filled': form.flights[flightIndex].destination_text || ($v.form.flights.$each[flightIndex].destination_text.$dirty && $v.form.flights.$each[flightIndex].destination_text.$invalid)  || departureFilled}"
        )
          .flight-widget-form__placeholder {{ $t('booking.arrival') }}
          span.form-item__error(v-if="$v.form.flights.$each[flightIndex].destination_text.$dirty && !$v.form.flights.$each[flightIndex].destination_text.required") {{ $t('forms.errors.required') }}
          .flight-widget-form__input
            input(
              type="text"
              @focus="inputFocus($event, 'departure', flightIndex)"
              @blur="inputBlur($event)"
              @input="inputChange($event, 'departure', flightIndex)"
              v-model="form.flights[flightIndex].destination_text"
            )

        .flight-widget-form__item.flight-widget-form__item--date.icon-calendar(
          :class="{ 'is-filled': form.flights[flightIndex].flight_date || ($v.form.flights.$each[flightIndex].flight_date.$dirty && $v.form.flights.$each[flightIndex].flight_date.$invalid) || dateFilled }"
        )
          .flight-widget-form__placeholder {{ $t('booking.flightDate') }}
          span.form-item__error(v-if="$v.form.flights.$each[flightIndex].flight_date.$dirty && !$v.form.flights.$each[flightIndex].flight_date.required") {{ $t('forms.errors.required') }}
          client-only
            date-picker.flight-widget-form__input(
              format="D MMM, dd"
              :language="locale"
              :monday-first="true"
              :disabled-dates="disabledDates"
              maximum-view="day"
              @opened="datepickerOpened(flightIndex)"
              @closed="datepickerClosed(flightIndex)"
              v-model="form.flights[flightIndex].flight_date"
              :ref="'datepicker' + flightIndex"
            )

          button.flight-widget-form__input-clear.icon-close(
            type="button"
            v-if="form.flights[flightIndex].flight_date"
            @click="form.flights[flightIndex].flight_date = null"
          )

        button.flight-widget-form__delete-row.icon-close(
          type="button"
          v-if="flightIndex > 0"
          @click="removeRow(flightIndex)"
        )

      button.btn.flight-widget-form__button(
        type="button"
        @click="showForm = true"
      ) {{ $t('next') }}

  transition(name="fade")
    .flight-widget-form__body(v-if="showForm && !successMessage")
      .form__title {{ $t('booking.yourData') }}
      .form__cols
        .form__col
          .form-item.form-item--light.icon-user(
            :class="{ 'has-error': $v.form.first_name.$dirty && $v.form.first_name.$invalid }"
          )
            span.form-item__error(v-if="$v.form.first_name.$dirty && !$v.form.first_name.required") {{ $t('forms.errors.required') }}
            input.form-field(
              type="text"
              name="first_name"
              v-model="form.first_name"
              maxlength="255"
              :placeholder="`${$t('forms.fields.name')} *`"
            )

        .form__col
          .form-item.form-item--light.icon-user(
            :class="{ 'has-error': $v.form.last_name.$dirty && $v.form.last_name.$invalid }"
          )
            input.form-field(
              type="text"
              name="last_name"
              v-model="form.last_name"
              maxlength="255"
              :placeholder="`${$t('forms.fields.lastName')} *`"
            )

        .form__col
          .form-item.form-item--light.icon-phone(
            :class="{ 'has-error': $v.form.phone_number.$dirty && $v.form.phone_number.$invalid }"
          )
            span.form-item__error(v-if="$v.form.phone_number.$dirty && !$v.form.phone_number.required") {{ $t('forms.errors.required') }}
            input.form-field(
              type="tel"
              name="phone_number"
              v-mask="'+###########'"
              v-model="form.phone_number"
              maxlength="18"
              pattern="[0-9]*"
              :placeholder="`${$t('forms.fields.phone')} *`"
            )

        .form__col
          .form-item.form-item--light.icon-email(
            :class="{ 'has-error': $v.form.email.$dirty && $v.form.email.$invalid }"
          )
            span.form-item__error(v-if="$v.form.email.$dirty && !$v.form.email.required") {{ $t('forms.errors.required') }}
            span.form-item__error(v-else-if="$v.form.email.$dirty && !$v.form.email.email") {{ $t('forms.errors.email') }}
            input.form-field(
              type="email"
              name="email"
              v-model="form.email"
              maxlength="254"
              placeholder="E-mail"
            )

      label.form__accept.checkbox.checkbox--light(v-if="settings && settings.agree_text")
        input(type="checkbox" name="accept" v-model="agree")
        div(v-html="settings.agree_text")

      .form__submit
        button.btn(type="button" :disabled="!agree" @click.prevent="submit") {{ $t('forms.buttons.send') }}

    .flight-widget-thank.form-thank(
      v-if="successMessage"
    )
      .form-thank__close(@click="successMessage = null") {{ $t('forms.buttons.close') }}
      div
        .form-thank__svg
        .form-thank__title(v-if="successTitle" v-html="successTitle")
        .form-thank__descr(v-if="successContent" v-html="successContent")
        .share-link(v-if="referralLink")
          .share-link__input-wrap
            .share-link__icon.icon-link
            .share-link__input
              .form-item.form-item--light
                input.form-field.form-field--sm.readonly(
                  type="text"
                  :value="referralLink"
                  readonly
                  ref="refInput"
                )

          .share-link__buttons
            button.btn.btn--sm.btn--simple(
              type="button"
              @click="copyStringToClipboard"
            ) {{ $t('forms.buttons.copy') }}
            button.btn.btn--sm.btn--simple.btn--secondary2(
              v-if="allowShare"
              type="button"
              @click="share"
            ) {{ $t('forms.buttons.share') }}
            .dropdown-wrap(v-else)
              transition(name="fade")
                ul.dropdown.dropdown--gray(
                  v-show="isShareDropdownShown"
                )
                  li(v-for="option in shareOptions")
                    .item(@click="shareSocial(option.value)") {{ option.text }}

              .btn.btn--sm.btn--simple.btn--secondary2(
                @click="isShareDropdownShown = !isShareDropdownShown"
              ) {{ $t('forms.buttons.share') }}

        .form-thank__send-link(v-if="emailTitle" v-html="emailTitle")
        .form-thank__social-title(v-if="settings && settings.form_socials_title" v-html="settings.form_socials_title")
        socials(classes="form-thank__socials")

  .flight-widget__add-more(
    @click="addMoreFlight"
  ) {{ $t('booking.addFlight') }}
</template>

<script>
import 'moment/locale/ru'
import ClickOutside from 'vue-click-outside'
import API from '@/api'
import { formMixin } from '@/mixins/forms'
import { validationMixin } from 'vuelidate'
import { email } from '@/utils/validators'
import { required } from 'vuelidate/lib/validators'
import { copyShareMixin } from '@/mixins/copy-share'
import { mapGetters, mapState } from 'vuex'
import { getReferralCode } from '@/utils/referrals'
import cloneDeep from 'lodash/cloneDeep'
import padStart from 'lodash/padStart'
import { execMetrikaMethod } from '@/utils/metrika'

export default {
  name: 'FlightWidget',

  computed: {
    ...mapGetters({
      settings: 'vars/settings'
    }),
    ...mapState({
      locale: state => state.locale
    })
  },

  created () {
    this.addMoreFlight()
  },

  data () {
    return {
      agree: true,
      dateFilled: false,
      departureFilled: false,
      destinationFilled: false,
      disabledDates: {
        to: new Date(Date.now() - 8640000)
      },
      errorMessages: null,
      form: {
        email: null,
        first_name: null,
        last_name: null,
        phone_number: null,
        flights: []
      },
      showForm: false,
      successMessage: false,
      submitting: false,
      triggers: []
    }
  },

  directives: { ClickOutside },

  methods: {
    addMoreFlight () {
      this.form.flights.push({
        origin_text: null,
        destination_text: null,
        flight_date: null
      })
    },

    datepickerOpened (index) {
      const refName = 'datepicker' + index
      this.$refs[refName][0].$el.closest('.flight-widget-form__item--date').classList.add('is-focus')
    },

    datepickerClosed (index) {
      const refName = 'datepicker' + index
      this.$refs[refName][0].$el.closest('.flight-widget-form__item--date').classList.remove('is-focus')
    },

    removeRow (index) {
      this.form.flights.splice(index, 1)
    },

    inputFocus (e, type, index) {
      e.target.closest('.flight-widget-form__item').classList.add('is-focus')

      this.dropdownIndex = index
    },

    inputChange (e, type, index) {
      if (e.target.value && e.target.value !== '') {
        if (type === 'destination') {
          this.destinationFilled = true
        }
        if (type === 'departure') {
          this.departureFilled = true
        }
        if (type === 'date') {
          this.dateFilled = true
        }
      } else {
        if (type === 'destination') {
          this.destinationFilled = false
        }
        if (type === 'departure') {
          this.departureFilled = false
        }
        if (type === 'date') {
          this.dateFilled = false
        }
      }
    },

    inputBlur (e) {
      e.target.closest('.flight-widget-form__item').classList.remove('is-focus')
    },

    submit () {
      if (this.submitting) {
        return false
      }

      this.errorMessages = null
      this.$v.$touch()
      if (this.$v.$invalid) {
        return false
      }

      execMetrikaMethod('reachGoal', ['form1-send'])
      this.submitting = true
      const vm = this
      let data = {}
      const refCode = getReferralCode()
      if (refCode) {
        data.referral_code = refCode
      }
      data = Object.assign(data, cloneDeep(this.form))
      data.flights.forEach(flight => {
        const year = 1900 + flight.flight_date.getYear()
        const month = flight.flight_date.getMonth() + 1
        const day = flight.flight_date.getDate()
        flight.flight_date = `${year}-${padStart(month, 2, '0')}-${padStart(day, 2, '0')}`
      })

      this.$axios.post(API.forms.booking(), data)
        .then(response => {
          this.successMessage = response.data.detail
          Object.keys(vm.form).forEach(k => {
            if (Object.prototype.hasOwnProperty.call(vm.form, k)) {
              vm.form[k] = null
            }
          })
          vm.form.flights = []
          vm.addMoreFlight()
          vm.$v.form.$reset()
          execMetrikaMethod('reachGoal', ['form1-success'])
          vm.$emit('submitted', response)
        })
        .catch(error => vm.parseFormErrors(error))
        .then(() => { vm.submitting = false })
    }
  },

  mixins: [copyShareMixin, formMixin, validationMixin],

  props: {
    emailTitle: {
      type: [String, null],
      required: false,
      default: null
    },
    copyButton: {
      type: [String, null],
      required: false,
      default: null
    },
    shareButton: {
      type: [String, null],
      required: false,
      default: null
    },
    successContent: {
      type: [String, null],
      required: false,
      default: null
    },
    successTitle: {
      type: [String, null],
      required: false,
      default: null
    },
    title: {
      type: [String, null],
      required: false,
      default: null
    }
  },

  validations: {
    form: {
      email: {
        email,
        required,
        fromServer (value) {
          if (value === null) return true
          return !(this.errorMessages && this.errorMessages.email)
        }
      },

      first_name: {
        required,
        fromServer (value) {
          if (value === '') return true
          return !(this.errorMessages && this.errorMessages.first_name)
        }
      },

      flights: {
        $each: {
          origin_text: { required },
          destination_text: { required },
          flight_date: { required }
        }
      },

      last_name: {
        fromServer (value) {
          if (value === '') return true
          return !(this.errorMessages && this.errorMessages.last_name)
        }
      },

      phone_number: {
        required,
        fromServer (value) {
          if (value === '') return true
          return !(this.errorMessages && this.errorMessages.phone_number)
        }
      }
    }
  },

  watch: {
    showForm () {
      if (this.showForm && this.triggers.indexOf('form1-next') < 0) {
        execMetrikaMethod('reachGoal', ['form1-next'])
        this.triggers.push('form1-next')
      }
    }
  }
}
</script>
